// Supports Array.keys(), Array.values(), and Array.entries()
// https://www.sitepoint.com/community/t/javascript-array-polyfills/193601/2
function _ArrayIterator(array, kind) {
  this._array = array;
  this._kind = kind;
  this._nextIndex = 0;
}

_ArrayIterator.prototype.next = function () {
  var currentIndex = this._nextIndex;

  // Are we done?
  if (currentIndex >= this._array.length) {
      return {'value': undefined, 'done': true};
  }

  // Get ready for next time
  this._nextIndex++;

  // Iterating keys?
  if (this._kind === 'key') {
      return {'value': currentIndex, 'done': false};
  }

  // Iterating values?
  if (this._kind === 'value') {
      return {'value': this._array[currentIndex], 'done': false};
  }

  // Iterating entries?
  if (this._kind === 'key+value') {
      return {'value': [currentIndex, this._array[currentIndex]], 'done': false};
  }
};